#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>

#define BUF_LEN         1024
#define REQUEST_LEN    4  // REQ\0

int main(int argc, char* argv[]){
    int ret, newfd, listener, addrlen, i, len; 
    
    fd_set master;                
    fd_set read_fds;              
    int fdmax;                    

    
    struct sockaddr_in my_addr, cl_addr;
    char buffer[BUF_LEN];
    
    time_t rawtime;
    struct tm * timeinfo;
      
    
    /* Creazione socket */
    listener = socket(AF_INET, SOCK_STREAM, 0);

    /* Creazione indirizzo di bind */
    memset(&my_addr, 0, sizeof(my_addr)); // Pulizia 
    my_addr.sin_family = AF_INET;
    my_addr.sin_port = htons(4242);
    my_addr.sin_addr.s_addr = INADDR_ANY;
    
    ret = bind(listener, (struct sockaddr*)&my_addr, sizeof(my_addr) );
    
    if( ret < 0 ){
        perror("Bind non riuscita\n");
        exit(0);
    }
    
    listen(listener, 10);
    
    // Reset FDs
    FD_ZERO(&master);
    FD_ZERO(&read_fds);

    // Add listener socket to the set
    FD_SET(listener, &master); 
    fdmax = listener;          
    
    while(1){
        
        // Reset the set
        read_fds = master;     
        
        // Mi blocco in attesa di descrottori pronti
        select(fdmax + 1, &read_fds, NULL, NULL, NULL);
        
        for(i = 0; i <= fdmax; i++) {  
                        
            if(FD_ISSET(i, &read_fds)) { 
                if(i == listener) {    
                    // Ho appena ricevuto una richiesta di connessione
                    addrlen = sizeof(cl_addr);
                    newfd = accept(listener,
                        (struct sockaddr *)&cl_addr, &addrlen);
                    
                    // Aggiungo la richiesta al set
                    FD_SET(newfd, &master); 
                    
                    // Aggiorno l'ID del massimo descrittore
                    if(newfd > fdmax){ fdmax = newfd; } 
                    
                } else {
                    
                    // Ho ricevuto una richiesta
                    ret = recv(i, (void*)buffer, REQUEST_LEN, 0);
                    
                    // Recupero l'ora corrente
                    time(&rawtime);
                    
                    // Converto l'ora
                    timeinfo = localtime(&rawtime);
                    
                    // Creo la risposta
                    sprintf(buffer, "%d:%d:%d", timeinfo->tm_hour, timeinfo->tm_min, timeinfo->tm_sec );
                    
                    // Invio la risposta
                    len = send(i, (void*) buffer, strlen(buffer)+1, 0);

                    if(ret < 0){
                        perror("Errore in fase di comunicazione con il client: \n");
                    }
                    
                    // Chiudo il socket e lo rimuovo dal set
                    close(i);
                    FD_CLR(i, &master);
                    
                }
            }
        }
    }
    
    close(listener);
    
}
    
    
    
    
